context("test-fusesma.sim")

test_that("Single run", {

  data(fuse_hydrological_timeseries)
  myDELTIM <- 1
  myMID <- 60

  set.seed(1)
  parameters <- generateParameters(1)

  x <- round(zoo::coredata(fusesma.sim(DATA = fuse_hydrological_timeseries,
                                       mid = myMID,
                                       deltim = myDELTIM,
                                       rferr_add = parameters$rferr_add,
                                       rferr_mlt = parameters$rferr_mlt,
                                       frchzne = parameters$frchzne,
                                       fracten = parameters$fracten,
                                       maxwatr_1 = parameters$maxwatr_1,
                                       percfrac = parameters$percfrac,
                                       fprimqb = parameters$fprimqb,
                                       qbrate_2a = parameters$qbrate_2a,
                                       qbrate_2b = parameters$qbrate_2b,
                                       qb_prms = parameters$qb_prms,
                                       maxwatr_2 = parameters$maxwatr_2,
                                       baserte = parameters$baserte,
                                       rtfrac1 = parameters$rtfrac1,
                                       percrte = parameters$percrte,
                                       percexp = parameters$percexp,
                                       sacpmlt = parameters$sacpmlt,
                                       sacpexp = parameters$sacpexp,
                                       iflwrte = parameters$iflwrte,
                                       axv_bexp = parameters$axv_bexp,
                                       sareamax = parameters$sareamax,
                                       loglamb = parameters$loglamb,
                                       tishape = parameters$tishape,
                                       qb_powr = parameters$qb_powr)), 3)

  y <- c(0, 0, 0, 0, 0.001, 0, 0, 0, 0, 0, 0.001, 0, 0, 0, 0, 0, 0.001,
         0, 0, 0.001, 0, 0.001, 0, 0.001, 0, 0.002, 0, 0.046, 0.005, 0,
         0.034, 0.312, 0.001, 0, 0, 0, 0, 0, 0.002, 0, 0.002, 0.002, 0.109,
         0.01, 0.003, 0.002, 0.003, 0.053, 0.003, 0.033, 0.005, 0.009,
         0.006, 0.085, 0.001, 0, 0, 0.001, 0.003, 0.037, 0.031, 0.006,
         0, 0.01, 0.007, 0.008, 0.003, 0.006, 0.001, 0.006, 0.005, 0,
         0.001, 0.002, 0.008, 0.009, 0.025, 0.008, 0.001, 0, 0, 0, 0,
         0.007, 0.012, 0.019, 0.008, 0.014, 0, 0.006, 0.01, 0, 0, 0, 0,
         0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.003, 0.018, 0.006, 0.001,
         0.001, 0.002, 0.019, 0.006, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
         0, 0, 0, 0, 0, 0, 0, 0, 0, 0.01, 0, 0.027, 0.001, 0.007, 0, 0.002,
         0, 0.001, 0, 0.018, 0.001, 0.013, 0.005, 0.011, 0.004, 0, 0.002,
         0.003, 0.009, 0.01, 0.006, 0.001, 0.001, 0.002, 0, 0, 0.001,
         0, 0, 0, 0, 0, 0.006, 0.002, 0.001, 0.001, 0, 0, 0, 0, 0, 0,
         0, 0, 0, 0, 0, 0, 0, 0.001, 0, 0, 0.001, 0, 0, 0, 0, 0.021, 0,
         0.003, 0.01, 0.002, 0.023, 0.018, 0.003, 0, 0.007, 0, 0, 0.002,
         0.001, 0, 0, 0, 0, 0, 0.001, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
         0, 0.012, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.001, 0, 0.005, 0.001,
         0.004, 0.002, 0.001, 0.001, 0, 0, 0.013, 0, 0.005, 0.001, 0,
         0.011, 0.026, 0, 0, 0.031, 0.001, 0.006, 0.001, 0, 0, 0, 0.006,
         0, 0, 0, 0, 0, 0.022, 0, 0.017, 0.007, 0.006, 0.003, 0, 0.01,
         0.002, 0.001, 0.011, 0.002, 0.017, 0.005, 0.006, 0, 0, 0, 0,
         0, 0, 0, 0.001, 0.009, 0.003, 0.002, 0.004, 0, 0, 0, 0, 0.016,
         0, 0.006, 0.002, 0, 0, 0, 0.001, 0, 0, 0, 0, 0, 0.001, 0.001,
         0.002, 0.003, 0.008, 0.03, 0, 0, 0.01, 0.026, 0, 0, 0, 0, 0.002,
         0.013, 0.001, 0.002, 0.011, 0.005, 0, 0.001, 0.003, 0, 0, 0.001,
         0.002, 0.018, 0, 0.003, 0.009, 0.002, 0.003, 0.001, 0, 0, 0,
         0.003, 0.001, 0.001, 0, 0, 0, 0, 0, 0.074, 0.041, 0.002, 0.002,
         0, 0, 0, 0, 0, 0.004, 0.012, 0.005, 0.001, 0.001, 0.008, 0.02,
         0.027, 0.006, 0.036, 0.002, 0, 0.018, 0.041, 0.01, 0, 0, 0, 0,
         0, 0.003, 0.003, 0.001, 0, 0, 0, 0, 0.025, 0.023, 0, 0, 0, 0,
         0, 0, 0, 0, 0.011, 0.02, 0.001, 0.016, 0.022, 0.067, 0.149, 0.048,
         0.004, 0, 0.022, 0.015, 0.147, 0.014, 0.024, 0.015, 0.017, 0.002,
         0.036, 0.035, 0.003, 0.003, 0, 0, 0, 0.001, 0.001, 0.003, 0.001,
         0, 0.004, 0, 0.037, 0, 0, 0.104, 0.013, 0.001, 0, 0.014, 0.088,
         0.001, 0, 0, 0.001, 0.007, 0.021, 0.015, 0.003, 0.002, 0, 0.006,
         0.007, 0.001, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.001, 0, 0.023, 0.015,
         0.023, 0, 0.01, 0.002, 0.051, 0.004, 0.079, 0.004, 0.012, 0.001,
         0.163, 0.032, 0.051, 0.022, 0.01, 0.003, 0.015, 0.042, 0.114,
         0.088, 0.002, 0, 0, 0, 0.002, 0, 0, 0, 0.023, 0.003, 0.004, 0,
         0, 0, 0.001, 0.001, 0.015, 0.079, 0.006, 0.009, 0.087, 0.075,
         0.013, 0.003, 0.086, 0.003, 0.043, 0.059, 0.011, 0.002, 0.003,
         0.031, 0.007, 0, 0.001, 0.001, 0.096, 0, 0.014, 0.012, 0.085,
         0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.046, 0.008, 0.091, 0.035,
         0.028, 0.101, 0.067, 0.097, 0.122, 0.03, 0.003, 0, 0.064, 0.003,
         0, 0.001, 0.041, 0.001, 0.028, 0, 0, 0, 0, 0, 0, 0, 0, 0.006,
         0.034, 0.001, 0.001, 0.003, 0, 0.128, 0.077, 0.023, 0.001, 0.001,
         0.001, 0, 0, 0.002, 0.136, 0.022, 0.012, 0.152, 0.041, 0.01,
         0.011, 0, 0, 0, 0, 0, 0, 0, 0.089, 0.001, 0.113, 0.233, 0.147,
         0.027, 0.251, 0.025, 0.049, 0.001, 0, 0, 0.014, 0.005, 0.007,
         0.001, 0, 0, 0, 0, 0, 0, 0.005, 0, 0, 0, 0, 0, 0, 0.007, 0.033,
         0, 0.001, 0, 0, 0.02, 0.001, 0.08, 0.006, 0.204, 0.089, 0.005,
         0.005, 0.004, 0.102, 0.059, 0.012, 0.002, 0.021, 0.018, 0.004,
         0, 0.002, 0, 0, 0.07, 0.022, 0.007, 0.076, 0.032, 0.017, 0.103,
         0.004, 0.002, 0.005, 0.05, 0.154, 0.099, 0.037, 0.08, 0.001,
         0.021, 0.072, 0.025, 0.048, 0.163, 0.279, 0.419, 0.182, 0.029,
         0.176, 0.061, 0.004, 0.21, 0.008, 0.005, 0.011, 0.005, 0.116,
         0.073, 0.001, 0.719, 0.006, 0.126, 0.051, 0.107, 0.57, 0.008,
         0.006, 0.002, 0.401, 0.216, 0.033, 0.094, 0.456, 0.332, 0.102,
         0.004, 0.004, 0.002, 0.001, 0.001, 0.002, 0.001, 0.004, 0.003,
         0.062, 0.068, 0.022, 0.188, 1.18, 1.188, 0.132, 0.004, 0.003,
         0.001, 0.001, 0.008, 0.108, 0.047, 0.006, 0.096, 0.199, 0.065,
         0.004, 0.005, 0.004, 0.003, 0.013, 0.003, 0.004, 0.005, 0.005,
         0.003, 0.143, 0.013, 0.007, 0.001, 0.003, 0.003, 0.015, 0.012,
         0.02, 0.001, 0.041, 0.103, 0.005, 0.061, 0.011, 0.006, 0.024,
         0.001, 0.001, 0.001, 0.001, 0.052, 0.006, 1.247, 0.099, 0.017,
         0.427, 0.002, 0.214, 0.34, 0.401, 0.998, 0.543, 0.11, 0.005,
         0.067, 0.596, 1.533, 0.56, 1.624, 1.672, 0.027, 0.235, 0.783,
         1.183, 1.243, 0.628, 0.958, 0.035, 1.845, 0.029, 0.005, 0.042,
         0.42, 0.013, 0.005, 0.008, 0.02, 0.005, 0.015, 0.042, 0.55, 0.146,
         0.219, 0.426, 0.463, 0.433, 0.008, 0.023, 0.005, 1.164, 0.352,
         0.257, 0.068, 0.203, 0.482, 0.013, 0.006, 0.006, 0.006, 0.006,
         0.081, 0.126, 0.121, 0.134, 0.114, 0.013, 0.006, 0.006, 0.006,
         0.006, 0.006, 0.006, 0.011, 0.006, 0.006, 0.006, 0.011, 0.006,
         0.006, 0.144, 0.011, 0.006, 1.772, 0.339, 0.262, 0.568, 0.781,
         0.011, 0.006, 0.006, 0.006, 0.944, 3.209, 1.27, 0.096, 1.561,
         0.642, 0.008, 0.874, 0.378, 0.11, 0.439, 0.008, 0.006, 0.154,
         0.044, 0.223, 0.758, 0.694, 0.006, 0.008, 0.006, 0.006, 0.006,
         0.006, 0.006, 0.006, 0.006, 0.006, 0.006, 0.006, 0.006, 0.006,
         0.006, 0.154, 0.34, 0.432, 0.641, 0.207, 2.076, 1.237, 0.37,
         0.093, 0.258, 0.182, 0.006, 0.029, 0.115, 0.447, 1.005, 0.824,
         0.452, 0.136, 0.345, 2.218, 0.054, 0.281, 0.067, 0.008, 0.572,
         0.026, 0.587, 0.092, 0.233, 0.006, 0.006, 0.006, 0.006, 0.447,
         0.011, 0.006, 0.785, 0.633, 0.419, 0.296, 0.342, 0.245, 0.006,
         0.011, 0.006, 0.006, 0.006, 0.569, 0.808, 0.019, 1.756, 0.087,
         0.006, 0.635, 0.26, 0.564, 0.077, 0.008, 0.006, 0.006, 0.006,
         0.006, 0.006, 0.006, 0.006, 0.006, 0.006, 0.024, 0.398, 0.008,
         0.008, 0.006, 0.006, 0.006, 0.006, 0.019, 0.752, 0.243, 0.856,
         0.036, 0.013, 0.202, 0.291, 0.991, 0.217, 1.062, 1.563, 0.171,
         0.578, 0.746, 0.629, 0.125, 0.382, 0.011, 0.006, 0.006, 0.006,
         0.929, 0.464, 0.344, 0.072, 1.161, 0.647, 0.039, 0.08, 0.006,
         0.006, 0.006, 0.006, 0.006, 0.006, 0.016, 0.013, 0.006, 0.176,
         0.008, 0.822, 0.024, 0.008, 0.011, 0.171, 0.095, 1.058, 0.812,
         1.659, 1.008, 0.791, 0.024, 0.413, 0.006, 1.007, 0.898, 0.25,
         0.024, 0.008, 0.008, 0.006, 0.006, 0.006, 0.006, 0.006, 0.006,
         0.006, 0.006, 0.006, 0.126, 0.019, 0.013, 0.062, 0.082, 0.006,
         0.639, 0.185, 0.013, 0.892, 0.585, 0.672, 0.962, 0.476, 0.034,
         0.108, 0.095, 0.098, 0.646, 0.787, 0.32, 0.943, 2.637, 0.027,
         0.042, 0.436, 0.068, 0.305, 0.669, 0.123, 1.612, 0.221, 0.019,
         0.013, 0.036, 0.125, 0.046, 1.174, 0.488, 0.34, 1.587, 3.204,
         1.093, 0.112, 0.012, 0.016, 0.012, 0.053, 0.02, 0.697, 2.085,
         0.051, 0.036, 0.013, 0.772, 1.776, 3.127, 4.233, 0.094, 1.149,
         0.331, 0.528, 1.776)

  expect_that(all(x==y), equals(TRUE))

})
